=== drivers/thermal/Makefile ===
#
# Makefile for sensor chip drivers.
#

obj-$(CONFIG_THERMAL)		+= thermal_sys.o
obj-$(CONFIG_THERMAL_FREQ)	+= thermal_freq.o
