=== drivers/staging/thermal_framework/Makefile ===
#
# Makefile for sensor chip drivers.
#
obj-$(CONFIG_THERMAL_FRAMEWORK)	+= thermal_framework.o \
					governor/
