=== drivers/media/video/omap4iss/Makefile ===
# Makefile for OMAP4 ISS driver

omap4-iss-objs += \
	iss.o iss_csi2.o iss_csiphy.o iss_video.o

obj-$(CONFIG_VIDEO_OMAP4) += omap4-iss.o
