=== debian/changelog ===
linux-ti-omap4 (3.2.0-1425.33) precise-proposed; urgency=low

  * Release Tracking Bug
    - LP: #1105112

  [ Paolo Pisati ]

  * rebased on Ubuntu-3.2.0-37.58

  [ Ubuntu: 3.2.0-37.58 ]

  * Release Tracking Bug
    - LP: #1104061
  * Revert "fsnotify: change locking order"
    - LP: #1101666
  * Revert "fsnotify: dont put marks on temporary list when clearing marks
    by group"
    - LP: #1101666
  * Revert "fsnotify: introduce locked versions of fsnotify_add_mark() and
    fsnotify_remove_mark()"
    - LP: #1101666
  * Revert "fsnotify: pass group to fsnotify_destroy_mark()"
    - LP: #1101666
  * Revert "fsnotify: use a mutex instead of a spinlock to protect a groups
    mark list"
    - LP: #1101666
  * Revert "fanotify: add an extra flag to mark_remove_from_mask that
    indicates wheather a mark should be destroyed"
    - LP: #1101666
  * Revert "fsnotify: take groups mark_lock before mark lock"
    - LP: #1101666
  * Revert "fsnotify: use reference counting for groups"
    - LP: #1101666
  * Revert "fsnotify: introduce fsnotify_get_group()"
    - LP: #1101666

 -- Paolo Pisati <paolo.pisati@canonical.com>  Fri, 25 Jan 2013 17:25:18 +0100

linux-ti-omap4 (3.2.0-1424.32) precise-proposed; urgency=low

  * Release Tracking Bug
    - LP: #1097595

  [ Paolo Pisati ]

  * rebased on Ubuntu-3.2.0-36.57

  [ Ubuntu: 3.2.0-36.57 ]

  * Release Tracking Bug
    - LP: #1097389
  * Revert "SAUCE: fsnotify: dont put marks on temporary list when clearing
    marks by group"
    - LP: #1096137
  * Revert "SAUCE: fsnotify: introduce locked versions of
    fsnotify_add_mark() and fsnotify_remove_mark()"
    - LP: #1096137
  * Revert "SAUCE: fsnotify: pass group to fsnotify_destroy_mark()"
    - LP: #1096137
  * Revert "SAUCE: fsnotify: use a mutex instead of a spinlock to protect a
    groups mark list"
    - LP: #1096137
  * Revert "SAUCE: fanotify: add an extra flag to mark_remove_from_mask
    that indicates wheather a mark should be destroyed"
    - LP: #1096137
  * Revert "SAUCE: fsnotify: take groups mark_lock before mark lock"
    - LP: #1096137
  * Revert "SAUCE: fsnotify: use reference counting for groups"
    - LP: #1096137
  * Revert "SAUCE: fsnotify: introduce fsnotify_get_group()"
    - LP: #1096137
  * fsnotify: introduce fsnotify_get_group()
    - LP: #1096137
  * fsnotify: use reference counting for groups
    - LP: #1096137
  * fsnotify: take groups mark_lock before mark lock
    - LP: #1096137
  * fanotify: add an extra flag to mark_remove_from_mask that indicates
    wheather a mark should be destroyed
    - LP: #1096137
  * fsnotify: use a mutex instead of a spinlock to protect a groups mark
    list
    - LP: #1096137
  * fsnotify: pass group to fsnotify_destroy_mark()
    - LP: #1096137
  * fsnotify: introduce locked versions of fsnotify_add_mark() and
    fsnotify_remove_mark()
    - LP: #1096137
  * fsnotify: dont put marks on temporary list when clearing marks by group
    - LP: #1096137
  * fsnotify: change locking order
    - LP: #1096137

 -- Paolo Pisati <paolo.pisati@canonical.com>  Fri, 11 Jan 2013 16:05:57 +0100

linux-ti-omap4 (3.2.0-1424.31) precise-proposed; urgency=low

  * Release Tracking Bug
    - LP: #1095797

  [ Paolo Pisati ]

  * rebased on Ubuntu-3.2.0-36.56

  [ Ubuntu: 3.2.0-36.56 ]

  * Release Tracking Bug
    - LP: #1095351
  * SAUCE: add eeprom_bad_csum_allow module parameter
    - LP: #1070182
  * SAUCE: samsung-laptop: disable in UEFI mode
    - LP: #1040557
  * SAUCE: usb: cdc-wdm: fix regression on buffer deallocation
    - LP: #1074157
  * SAUCE: exec: do not leave bprm->interp on stack
    - LP: #1068888
    - CVE-2012-4530
  * Add ceph to virtual kernel flavor
    - LP: #1063784
  * SAUCE: fsnotify: introduce fsnotify_get_group()
    - LP: #922906
  * SAUCE: fsnotify: use reference counting for groups
    - LP: #922906
  * SAUCE: fsnotify: take groups mark_lock before mark lock
    - LP: #922906
  * SAUCE: fanotify: add an extra flag to mark_remove_from_mask that
    indicates wheather a mark should be destroyed
    - LP: #922906
  * SAUCE: fsnotify: use a mutex instead of a spinlock to protect a groups
    mark list
    - LP: #922906
  * SAUCE: fsnotify: pass group to fsnotify_destroy_mark()
    - LP: #922906
  * SAUCE: fsnotify: introduce locked versions of fsnotify_add_mark() and
    fsnotify_remove_mark()
    - LP: #922906
  * SAUCE: fsnotify: dont put marks on temporary list when clearing marks
    by group
    - LP: #922906
  * SAUCE: tools: hv: Netlink source address validation allows DoS
    - LP: #1084777
    - CVE-2012-5532
  * drm/i915: add Ivy Bridge GT2 Server entries
    - LP: #1087302
  * drm/i915: EBUSY status handling added to i915_gem_fault().
    - LP: #1087302
  * UBIFS: introduce categorized lprops counter
    - LP: #1087865
  * UBIFS: fix mounting problems after power cuts
    - LP: #1087865
  * futex: Handle futex_pi OWNER_DIED take over correctly
    - LP: #1087865
  * mac80211: sync acccess to tx_filtered/ps_tx_buf queues
    - LP: #1087865
  * ASoC: wm8978: pll incorrectly configured when codec is master
    - LP: #1087865
  * device_cgroup: fix RCU usage
    - LP: #1087865
  * ASoC: dapm: Use card_list during DAPM shutdown
    - LP: #1087865
  * s390/signal: set correct address space control
    - LP: #1087865
  * wireless: allow 40 MHz on world roaming channels 12/13
    - LP: #1087865
  * drm/i915/sdvo: clean up connectors on intel_sdvo_init() failures
    - LP: #1087865
  * s390/gup: add missing TASK_SIZE check to get_user_pages_fast()
    - LP: #1087865
  * USB: option: add Novatel E362 and Dell Wireless 5800 USB IDs
    - LP: #1087865
  * USB: option: add Alcatel X220/X500D USB IDs
    - LP: #1087865
  * drm/radeon: fix logic error in atombios_encoders.c
    - LP: #1087865
  * ttm: Clear the ttm page allocated from high memory zone correctly
    - LP: #1087865
  * memcg: oom: fix totalpages calculation for memory.swappiness==0
    - LP: #1087865
  * tmpfs: change final i_blocks BUG to WARNING

